--versión preliminar diccionario con 700 frases,
require "import"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"
import "java.util.Locale"
import "android.content.Intent"

local substitutionTable = {
["amigo"] = "amigo,",
["sirva"] = "sirva,",
["guste"] = "guste,",
["tal vez"] = "tal vez,",
["pero"] = "pero,",
["lamentablemente"] = "lamentablemente,",
["me explico"] = "me explico.",
["Me explico"] = "Me explico.",
["compañera"] = "compañera,",
["correcto"] = "correcto.",
["grupo"] = "grupo,",
["reportándome"] = "reportándome,",
["descanso"] = "descanso,",
["lo siguiente"] = "lo siguiente,",
["correspondiente"] = "correspondiente.",
["puntuación"] = "puntuación.",
["continuación"] = "continuación,",
["pasos"] = "pasos.",
["Hola"] = "Hola,",
["Sergio"] = "Sergio.",
["compañero"] = "compañero,",
["alegría"] = "alegría,",
["felicidad"] = "felicidad,",
["sueño"] = "sueño,",
["risa"] = "risa,",
["esperanza"] = "esperanza,",
["amor"] = "amor,",
["paz"] = "paz,",
["vida"] = "vida,",
["éxito"] = "éxito,",
["valentía"] = "valentía,",
["fortaleza"] = "fortaleza,",
["sabiduría"] = "sabiduría,",
["creatividad"] = "creatividad,",
["inspiración"] = "inspiración,",
["generosidad"] = "generosidad,",
["compasión"] = "compasión,",
["gratitud"] = "gratitud,",
["humildad"] = "humildad,",
["paciencia"] = "paciencia,",
["sinceridad"] = "sinceridad,",
["amabilidad"] = "amabilidad,",
["respeto"] = "respeto,",
["optimismo"] = "optimismo,",
["coraje"] = "coraje,",
["amistad"] = "amistad,",
["aprecio"] = "aprecio,",
["determinación"] = "determinación,",
["alegría"] = "alegría,",
["compañerismo"] = "compañerismo,",
["perseverancia"] = "perseverancia,",
["belleza"] = "belleza,",
["integridad"] = "integridad,",
["satisfacción"] = "satisfacción,",
["fascinación"] = "fascinación,",
["magia"] = "magia,",
["admiración"] = "admiración,",
["sorpresa"] = "sorpresa,",
["asombro"] = "asombro,",
["resiliencia"] = "resiliencia,",
["entusiasmo"] = "entusiasmo,",
["humor"] = "humor,",
["risa"] = "risa,",
["tristeza"] = "tristeza,",
["soledad"] = "soledad,",
["desafío"] = "desafío,",
["frustración"] = "frustración,",
["miedo"] = "miedo,",
["preocupación"] = "preocupación,",
["dolor"] = "dolor,",
["ira"] = "ira,",
["culpa"] = "culpa,",
["rechazo"] = "rechazo,",
["incertidumbre"] = "incertidumbre,",
["estrés"] = "estrés,",
["decepción"] = "decepción,",
["envidia"] = "envidia,",
["culpa"] = "culpa,",
["vergüenza"] = "vergüenza,",
["tristeza"] = "tristeza,",
["sorpresa"] = "sorpresa,",
["enojo"] = "enojo,",
["alegría"] = "alegría,",
["felicidad"] = "felicidad,",
["amor"] = "amor,",
["paz"] = "paz,",
["esperanza"] = "esperanza,",
["satisfacción"] = "satisfacción,",
["agradecimiento"] = "agradecimiento,",
["entusiasmo"] = "entusiasmo,",
["diversión"] = "diversión,",
["compañerismo"] = "compañerismo,",
["elogio"] = "elogio,",
["apoyo"] = "apoyo,",
["cariño"] = "cariño,",
["celebración"] = "celebración,",
["recompensa"] = "recompensa,",
["logro"] = "logro,",
["gracia"] = "gracia,",
["generosidad"] = "generosidad,",
["compasión"] = "compasión,",
["solidaridad"] = "solidaridad,",
["humildad"] = "humildad,",
["sinceridad"] = "sinceridad,",
["respeto"] = "respeto,",
["bondad"] = "bondad,",
["afecto"] = "afecto,",
["ternura"] = "ternura,",
["cuidado"] = "cuidado,",
["emoción"] = "emoción,",
["gratitud"] = "gratitud,",
["alivio"] = "alivio,",
["esperanza"] = "esperanza,",
["confianza"] = "confianza,",
["seguridad"] = "seguridad,",
["libertad"] = "libertad,",
["inspiración"] = "inspiración,",
["motivación"] = "motivación,",
["creatividad"] = "creatividad,",
["oportunidad"] = "oportunidad,",
["desafío"] = "desafío,",
["aventura"] = "aventura,",
["éxito"] = "éxito,",
["logro"] = "logro,",
["realización"] = "realización,",
["progreso"] = "progreso,",
["satisfacción"] = "satisfacción,",
["aprendizaje"] = "aprendizaje,",
["conocimiento"] = "conocimiento,",
["descubrimiento"] = "descubrimiento,",
["crecimiento"] = "crecimiento,",
["transformación"] = "transformación,",
["adaptabilidad"] = "adaptabilidad,",
["innovación"] = "innovación,",
["riqueza"] = "riqueza,",
["abundancia"] = "abundancia,",
["prosperidad"] = "prosperidad,",
["equilibrio"] = "equilibrio,",
["belleza"] = "belleza,",
["armonía"] = "armonía,",
["gracia"] = "gracia,",
["elegancia"] = "elegancia,",
["magia"] = "magia,",
["atracción"] = "atracción,",
["admiración"] = "admiración,",
["fascinación"] = "fascinación,",
["sorpresa"] = "sorpresa,",
["asombro"] = "asombro,",
["emociones"] = "emociones,",
["sentimientos"] = "sentimientos,",
["experiencia"] = "experiencia,",
["memoria"] = "memoria,",
["recuerdo"] = "recuerdo,",
["nostalgia"] = "nostalgia,",
["aflicción"] = "aflicción,",
["melancolía"] = "melancolía,",
["dolor"] = "dolor,",
["soledad"] = "soledad,",
["desesperación"] = "desesperación,",
["desilusión"] = "desilusión,",
["frustración"] = "frustración,",
["tristeza"] = "tristeza,",
["desánimo"] = "desánimo,",
["angustia"] = "angustia,",
["ansiedad"] = "ansiedad,",
["miedo"] = "miedo,",
["preocupación"] = "preocupación,",
["inseguridad"] = "inseguridad,",
["incertidumbre"] = "incertidumbre,",
["presión"] = "presión,",
["estres"] = "estres,",
["agobio"] = "agobio,",
["agotamiento"] = "agotamiento,",
["decepción"] = "decepción,",
["envidia"] = "envidia,",
["celos"] = "celos,",
["injusticia"] = "injusticia,",
["ira"] = "ira,",
["rabia"] = "rabia,",
["resentimiento"] = "resentimiento,",
["culpa"] = "culpa,",
["arrepentimiento"] = "arrepentimiento,",
["vergüenza"] = "vergüenza,",
["incompetencia"] = "incompetencia,",
["fracaso"] = "fracaso,",
["rechazo"] = "rechazo,",
["soledad"] = "soledad,",
["abandono"] = "abandono,",
["traición"] = "traición,",
["humillación"] = "humillación,",
["desprecio"] = "desprecio,",
["inferioridad"] = "inferioridad,",
["inutilidad"] = "inutilidad,",
["pesimismo"] = "pesimismo,",
["negatividad"] = "negatividad,",
["desesperanza"] = "desesperanza,",
["oscuridad"] = "oscuridad,",
["desesperación"] = "desesperación,",
["amargura"] = "amargura,",
["desamparo"] = "desamparo,",
["sufrimiento"] = "sufrimiento,",
    ["chino"] = "Jieshuo.",
    ["hola"] = "¡Hola!",
    ["adiós"] = "Adiós.",
    ["gracias"] = "¡Gracias!",
    ["por favor"] = "Por favor.",
    ["bienvenido"] = "¡Bienvenido!",
    ["feliz cumpleaños"] = "¡Feliz cumpleaños!",
    ["lo siento"] = "Lo siento.",
    ["te amo"] = "Te amo.",
    ["buenos días"] = "Buenos días.",
    ["buenas tardes"] = "Buenas tardes.",
    ["buenas noches"] = "Buenas noches.",
    ["qué tal"] = "¿Qué tal?",
    ["qué pasa"] = "¿Qué pasa?",
    ["excelente"] = "¡Excelente!",
    ["genial"] = "¡Genial!",
    ["perfecto"] = "¡Perfecto!",
    ["fantástico"] = "¡Fantástico!",
    ["increíble"] = "¡Increíble!",
    ["interesante"] = "Interesante.",
    ["felicidades"] = "¡Felicidades!",
    ["buen provecho"] = "¡Buen provecho!",
    ["salud"] = "¡Salud!",
    ["buen viaje"] = "¡Buen viaje!",
    ["buenas noticias"] = "¡Buenas noticias!",
    ["mala suerte"] = "Mala suerte.",
    ["buen trabajo"] = "¡Buen trabajo!",
    ["mucho gusto"] = "Mucho gusto.",
    ["bien hecho"] = "¡Bien hecho!",
    ["qué lindo"] = "¡Qué lindo!",
    ["por supuesto"] = "Por supuesto.",
    ["claro que sí"] = "¡Claro que sí!",
    ["no hay problema"] = "No hay problema.",
    ["me encanta"] = "Me encanta.",
    ["qué divertido"] = "¡Qué divertido!",
    ["te felicito"] = "¡Te felicito!",
    ["qué suerte"] = "¡Qué suerte!",
    ["qué amable"] = "¡Qué amable!",
    ["me hace feliz"] = "Me hace feliz.",
    ["qué agradable"] = "¡Qué agradable!",
    ["qué maravilla"] = "¡Qué maravilla!",
    ["me siento bien"] = "Me siento bien.",
    ["qué interesante"] = "¡Qué interesante!",
    ["qué bonito"] = "¡Qué bonito!",
    ["me alegra"] = "Me alegra.",
    ["qué genial"] = "¡Qué genial!",
    ["me gusta"] = "Me gusta.",
    ["me divierte"] = "Me divierte.",
    ["me fascina"] = "Me fascina.",
    ["me sorprende"] = "Me sorprende.",
    ["me emociona"] = "Me emociona.",
    ["me motiva"] = "Me motiva.",
    ["me inspira"] = "Me inspira.",
    ["me relaja"] = "Me relaja.",
    ["me tranquiliza"] = "Me tranquiliza.",
    ["me reconforta"] = "Me reconforta.",
    ["me impresiona"] = "Me impresiona.",
    ["me entusiasma"] = "Me entusiasma.",
    ["me agrada"] = "Me agrada.",
    ["me encanta escuchar eso"] = "Me encanta escuchar eso.",
    ["me hace sentir bien"] = "Me hace sentir bien.",
    ["me hace feliz saberlo"] = "Me hace feliz saberlo.",
    ["me alegra mucho"] = "Me alegra mucho.",
    ["me divierte mucho"] = "Me divierte mucho.",
    ["me fascina muchísimo"] = "Me fascina muchísimo.",
    ["me sorprende gratamente"] = "Me sorprende gratamente.",
    ["me emociona de verdad"] = "Me emociona de verdad.",
    ["me motiva enormemente"] = "Me motiva enormemente.",
    ["me inspira mucho"] = "Me inspira mucho.",
    ["me relaja por completo"] = "Me relaja por completo.",
    ["me tranquiliza de verdad"] = "Me tranquiliza de verdad.",
    ["me reconforta mucho"] = "Me reconforta mucho.",
    ["me impresiona de sobremanera"] = "Me impresiona de sobremanera.",
    ["me entusiasma enormemente"] = "Me entusiasma enormemente.",
    ["me agrada muchísimo"] = "Me agrada muchísimo.",
    ["es un placer conocerte"] = "¡Es un placer conocerte!",
    ["estoy feliz de verte"] = "¡Estoy feliz de verte!",
    ["me alegro de verte"] = "¡Me alegro de verte!",
    ["me da gusto verte"] = "¡Me da gusto verte!",
    ["es un honor estar aquí"] = "¡Es un honor estar aquí!",
    ["es un privilegio trabajar contigo"] = "¡Es un privilegio trabajar contigo!",
    ["te admiro mucho"] = "¡Te admiro mucho!",
    ["eres increíble"] = "¡Eres increíble!",
    ["eres genial"] = "¡Eres genial!",
    ["eres fantástico"] = "¡Eres fantástico!",
    ["eres maravilloso"] = "¡Eres maravilloso!",
    ["eres asombroso"] = "¡Eres asombroso!",
    ["eres impresionante"] = "¡Eres impresionante!",
    ["eres increíblemente talentoso"] = "¡Eres increíblemente talentoso!",
    ["eres muy inteligente"] = "¡Eres muy inteligente!",
    ["eres una inspiración"] = "¡Eres una inspiración!",
    ["eres un ejemplo a seguir"] = "¡Eres un ejemplo a seguir!",
    ["eres valiente"] = "¡Eres valiente!",
    ["eres fuerte"] = "¡Eres fuerte!",
    ["eres perseverante"] = "¡Eres perseverante!",
    ["eres admirable"] = "¡Eres admirable!",
    ["eres un líder nato"] = "¡Eres un líder nato!",
    ["eres un verdadero campeón"] = "¡Eres un verdadero campeón!",
    ["eres una persona excepcional"] = "¡Eres una persona excepcional!",
    ["tienes un talento extraordinario"] = "¡Tienes un talento extraordinario!",
    ["tienes una habilidad increíble"] = "¡Tienes una habilidad increíble!",
    ["tienes un don especial"] = "¡Tienes un don especial!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",
    ["tienes un corazón de oro"] = "¡Tienes un corazón de oro!",
    ["tienes una energía contagiosa"] = "¡Tienes una energía contagiosa!",
    ["tienes una personalidad encantadora"] = "¡Tienes una personalidad encantadora!",
    ["tienes un espíritu inquebrantable"] = "¡Tienes un espíritu inquebrantable!",
    ["tienes una determinación admirable"] = "¡Tienes una determinación admirable!",
    ["tienes una pasión inspiradora"] = "¡Tienes una pasión inspiradora!",
    ["tienes una sonrisa radiante"] = "¡Tienes una sonrisa radiante!",
    ["tienes una voz cautivadora"] = "¡Tienes una voz cautivadora!",
    ["tienes un estilo único"] = "¡Tienes un estilo único!",
    ["tienes un carisma irresistible"] = "¡Tienes un carisma irresistible!",
    ["tienes una presencia magnética"] = "¡Tienes una presencia magnética!",
    ["tienes una belleza excepcional"] = "¡Tienes una belleza excepcional!",
    ["tienes un encanto especial"] = "¡Tienes un encanto especial!",
    ["tienes un sentido del humor genial"] = "¡Tienes un sentido del humor genial!",
    ["tienes una inteligencia deslumbrante"] = "¡Tienes una inteligencia deslumbrante!",
    ["tienes un corazón bondadoso"] = "¡Tienes un corazón bondadoso!",
    ["tienes una mente creativa"] = "¡Tienes una mente creativa!",
    ["tienes una energía positiva"] = "¡Tienes una energía positiva!",
    ["tienes una actitud inspiradora"] = "¡Tienes una actitud inspiradora!",
    ["tienes una personalidad magnífica"] = "¡Tienes una personalidad magnífica!",
    ["tienes una esencia única"] = "¡Tienes una esencia única!",
    ["tienes un talento excepcional"] = "¡Tienes un talento excepcional!",
    ["tienes una habilidad asombrosa"] = "¡Tienes una habilidad asombrosa!",
    ["tienes un don extraordinario"] = "¡Tienes un don extraordinario!",
    ["tienes una mente brillante"] = "¡Tienes una mente brillante!",

}

function capitalizeFirstWord(text)
    local firstChar = text:sub(1, 1)
    local restOfString = text:sub(2)
    return firstChar:upper() .. restOfString
end

function substituteWords(text)
    for word, substitution in pairs(substitutionTable) do
        text = text:gsub("%f[%a]" .. word .. "%f[%A]", substitution)
    end
    return text
end

function capitalizeAfterPeriod(text)
    return text:gsub("(%.[%s%p]*%a)", function(match)
        local char = match:sub(-1)
        local capitalizedChar = char:upper()
        return match:sub(1, -2) .. capitalizedChar
    end)
end

function addPunctuation(text)
    local lastChar = text:sub(-1)
    local punctuation = { ".", "!", "?" }
    local hasPunctuation = false

    for _, p in ipairs(punctuation) do
        if lastChar == p then
            hasPunctuation = true
            break
        end
    end

    if not hasPunctuation then
        text = text .. "."
    end

    return text
end

function kill()
    speechRecognizer.destroy()
    speechRecognizer = nil
    return true
end

function startListening()
    speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)
    speechListener = RecognitionListener{
        onResults = function(results)
            data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data ~= nil and data.size() > 0 then
                local recognizedText = data.get(0)
                recognizedText = capitalizeFirstWord(recognizedText)
                recognizedText = substituteWords(recognizedText)
                recognizedText = capitalizeAfterPeriod(recognizedText)
                recognizedText = addPunctuation(recognizedText)
                service.paste(recognizedText .. "\n")
service.speak(recognizedText)
            end
            kill()
        end,
        onError = function()
            kill()
            startListening()
        end
    }
    recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, Locale.getDefault())
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())
    speechRecognizer.startListening(recognizerIntent)
    speechRecognizer.setRecognitionListener(speechListener)
end

startListening()
return true